const dout=Components.utils.reportError;

const Ci=Components.interfaces;
const PM_URI="chrome://lightsms/accounts/";
const PREF_BRANCH="extensions.lightsms.accounts.";

var main;
var prefBranch;
var accountsChanged=false;
var arAccounts;
var arDeleted;
var keyNum;

function onLoad() {
  keyNum=0;
  main=Components.classes["@mozilla.org/LightSMS;1"]
          .getService(Components.interfaces.nsILightSMS);
  var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Ci.nsIPrefService);
  prefBranch = prefService.getBranch("");

  arAccounts=[];
  arDeleted=[];  
  var obj=document.getElementById("hosts");
  var ar=main.getHostIDs({});
  for each(var id in ar){
    var s=main.getHostName(id);
    if(s==null)continue;
    obj.appendItem(s,id);
  }
  obj.selectedIndex=0;  
  
  var n=main.getAccountsNumber();
  for(var i=0;i<n;i++){
    var o=decodeObject(main.getAccountInfo(i));
    _getValues(o,false,false);
    addItem(o);
  }
  
  onSelect(-1); 
}
function getIndex(host,user){
  user=getFullUsername(host,user);
  var o;
  for(var i in arAccounts){
    o=arAccounts[i];
    if(o.id==host&&o.user==user){
      return i;
      break;
    }
  }
  return -1;
}
function getFullUsername(host,user){
  var hostStr=main.getScriptVal(host,"hostString");
  if(hostStr&&user.indexOf("@")==-1){
    user=user+"@"+hostStr;
  }else if((hostStr=="")&&user.indexOf("@")!=-1){
    user=user.substring(0,user.indexOf("@"));
  }
  return user;
}
function _getValues(o,isNew,byUser){
  o.enabled=true; 
  o.order=null;
  o.isNew=isNew;  
  if(isNew&&byUser){//user input
  }else{
    var prefStr=PREF_BRANCH+o.id+"."+o.user+".";    
    try{
      o.enabled=prefBranch.getBoolPref(prefStr+"enabled");
    }catch(e){}      
    try{
      o.order=prefBranch.getIntPref(prefStr+"order");
    }catch(e){} 
  }
}
function _addAcount(host,user,passwd,byUser){//add new account (user, import)
  user=getFullUsername(host,user);
  var i=getIndex(host,user);
  if(i<0){//new account
    var o={};
    o.id=host;
    o.user=user;
    o.password=passwd;
    _getValues(o,true,byUser);
    addItem(o);
  }else{//account exists.
    if(byUser)return user;
    var n={};
    n.id=host;
    n.user=user;
    n.password=passwd;  
    _getValues(n,false,byUser);
    delete n.isNew;
    var o=arAccounts[i];
    var same=true;
    for(var i in n){
      if(n[i]!=o[i]){
        same=false;
        break;
      }
    }
    if(same)return user;
    for(var i in n)o[i]=n[i];
    o.isNew=true;
  }
  accountsChanged=true;
  return user;
}
function onSelect(aIndex){
  if(aIndex<0){
    document.getElementById("username").value="";
    document.getElementById("password").value="";
    current=null;
    setAddMode(true);    
  }else{
    var o=arAccounts[aIndex];
    document.getElementById("hosts").value=o.id;
    document.getElementById("username").value=o.user;
    document.getElementById("password").value=o.password;
    current=o;
    setAddMode(false);    
  }
}
function checkIsNew(){
  var user=document.getElementById("username").value;
  if(!user){
    current=null;
    return;
  }
  var host=document.getElementById("hosts").value;
  var n=getIndex(host,user);
  current=n<0?null:arAccounts[n];
  setAddMode(n<0);
}
function setAddMode(isNew){
  document.getElementById("btn-add").disabled=!isNew;
  document.getElementById("btn-delete").disabled=isNew;
}
function onAdd(){
  var user=document.getElementById("username").value;
  if(!user)return;
  var passwd=document.getElementById("password").value;
  if(!passwd)return;
  var host=document.getElementById("hosts").value;
  user=_addAcount(host,user,passwd,true);
  document.getElementById("username").value=user;
  checkIsNew();
}
function onDelete(){
  var obj=document.getElementById("accounts");
  var index=obj.selectedIndex;
  if(index<0)return;
  var o=arAccounts[index];
  arDeleted.push(o);
  obj.removeItemAt(index);
  arAccounts.splice(index,1);
  accountsChanged=true;
}
function setValue(name,val){
  if(current){
    current[name]=val;
    current.isNew=true;
    accountsChanged=true;    
  }
}
function onMove(d){
  if(current){
    var list=document.getElementById("accounts");
    var em=document.getElementById(current.key);
    var index=list.getIndexOfItem(em);  
    var to=(current.order==null?index:current.order)+d;    
    if(to<0||to>=arAccounts.length)return;
    current.order=to;    
    arAccounts.splice(index,1);
    arAccounts.splice(to,0,current);
    for(var i=0;i<arAccounts.length;i++){
      var o=arAccounts[i];
      if(o.order!=null)o.order=i;
    }    
    list.removeChild(em);
    list.insertBefore(em,list.getItemAtIndex(to));
    list.selectedItem=em;
    accountsChanged=true;        
  }
}

function onAccept() {
  if(accountsChanged){
    var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
    for each(var o in arDeleted){//check deleted accounts;
      main.removePassword(PM_URI+o.id,o.user);
      var s=PREF_BRANCH+o.id+"."+o.user;
      try{ prefBranch.deleteBranch(s); }catch(e){}
    }
    if(arDeleted)prefService.savePrefFile(null);
    
    for each(var o in arAccounts){//check newly added accounts
      _setBool(o.id,o.user,"enabled",o.enabled);    
      _setInt(o.id,o.user,"order",o.order,null);
    }
    
    for each(var o in arAccounts){
      if(o.isNew&&o.password){
        main.setPassword(PM_URI+o.id,o.user,o.password);
      }
    }      
    main.initHandlers();    
  }
  return false;
}
function onCancel(){
  var prefService = Components.classes["@mozilla.org/preferences-service;1"]
                              .getService(Components.interfaces.nsIPrefService);
  var branch = prefService.getBranch("browser.preferences.");
  if((branch.getBoolPref("instantApply"))){//not window. close button only
    onAccept();
  }
}
function _setBool(host,user,name,val){
  var prefStr=PREF_BRANCH+host+"."+user+"."+name;
  var t=null;
  try{
    t=prefBranch.getBoolPref(prefStr);
  }catch(e){}
  if(t!=val){
    prefBranch.setBoolPref(prefStr,val);
  }
}
function _setInt(host,user,name,val,defVal){
  var prefStr=PREF_BRANCH+host+"."+user+"."+name;
  var t=null;
  try{
    t=prefBranch.getIntPref(prefStr);
  }catch(e){}
  if(t!=val){
    if(val!=defVal)prefBranch.setIntPref(prefStr,val);
    else{
      try{prefBranch.clearUserPref(prefStr);}catch(e){}
    }
  }
}


function addItem(o){//add item in the list
  var key=keyNum++;
  o.key=key;
  arAccounts.push(o);

  var obj = document.createElement("listitem");
  obj.id=key;
  obj.setAttribute("allowevents","true");
    var ch = document.createElement("listcell");
      var ch1 = document.createElement("vbox");
      ch1.setAttribute("flex","1");
      ch1.setAttribute("align","center");
        var ch2 = document.createElement("checkbox");
        ch2.setAttribute("checked",o.enabled);
        ch2.setAttribute("onclick","setEnabled(this.checked,"+key+")");
        ch1.appendChild(ch2);
      ch.appendChild(ch1);
    obj.appendChild(ch);
    ch = document.createElement("listcell");
    ch.setAttribute("label",main.getHostName(o.id));
    obj.appendChild(ch);
    ch = document.createElement("listcell");
    ch.setAttribute("label",o.user);
    obj.appendChild(ch);
    ch = document.createElement("listcell");
    ch.setAttribute("label",o.count>=0?o.count:"");
    obj.appendChild(ch);    
  document.getElementById("accounts").appendChild(obj);
}
function getAccount(aKey){
  for each(var o in arAccounts){
    if(o.key==aKey)return o;
  }
  return null;
}
function setEnabled(disable,aKey){
  var o=getAccount(aKey);
  o.enabled=!disable;
  accountsChanged=true;
}




function decodeObject(str){
  var ar=str.split(",");
  var data={};
  for each(var o in ar){
    var d=o.split(":");
    data[unescape(d[0])]=d[1]=="null"?null:unescape(d[1]);
  }
  return data;
}